---
title: 'SyntaxError: "x" is a reserved identifier'
slug: Web/JavaScript/Reference/Errors/Reserved_identifier
tags:
  - Error
  - Errors
  - JavaScript
  - SyntaxError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "<em>variable</em> is a reserved identifier" occurs when <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Keywords">reserved keywords</a> are used as identifiers.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">SyntaxError: The use of a future reserved word for an identifier is invalid (Edge)
SyntaxError: "x" is a reserved identifier (Firefox)
SyntaxError: Unexpected reserved word (Chrome)</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("SyntaxError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p><a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Keywords">Reserved keywords</a> will throw in if they are used as identifiers. These are reserved in strict mode and sloppy mode:</p>

<ul>
 <li><code>enum</code></li>
</ul>

<p>The following are only reserved when they are found in strict mode code:</p>

<ul class="threecolumns">
 <li><code>implements</code></li>
 <li><code>interface</code></li>
 <li>{{jsxref("Statements/let", "let")}}</li>
 <li><code>package</code></li>
 <li><code>private</code></li>
 <li><code>protected</code></li>
 <li><code>public</code></li>
 <li><code>static</code></li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Strict_and_non-strict_reserved_keywords">Strict and non-strict reserved keywords</h3>

<p>The <code>enum</code> identifier is generally reserved.</p>

<pre class="brush: js example-bad">var enum = { RED: 0, GREEN: 1, BLUE: 2 };
// SyntaxError: enum is a reserved identifier
</pre>

<p>In strict mode code, more identifiers are reserved.</p>

<pre class="brush: js example-bad">"use strict";
var package = ["potatoes", "rice", "fries"];
// SyntaxError: package is a reserved identifier
</pre>

<p>You'll need to rename these variables.</p>

<pre class="brush: js example-good">var colorEnum = { RED: 0, GREEN: 1, BLUE: 2 };
var list = ["potatoes", "rice", "fries"];</pre>

<h3 id="Update_older_browsers">Update older browsers</h3>

<p>If you are using an older browser that does not yet implement <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/let">let</a></code> or <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/class">class</a></code>, for example, you should update to a more recent browser version that does support these new language features.</p>

<pre class="brush: js">"use strict";
class DocArchiver {}

// SyntaxError: class is a reserved identifier
// (throws in older browsers only, e.g. Firefox 44 and older)
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://wiki.c2.com/?GoodVariableNames">Good variable names</a></li>
</ul>
